use crate::prelude::*;
use library_loader::load_function_ptrs;

use std::os::raw::c_char;
use std::os::raw::c_void;

pub type PFN_vkDebugReportCallbackEXT = extern "system" fn(
    VkDebugReportFlagsEXT,
    VkDebugReportObjectTypeEXT,
    u64,
    usize,
    i32,
    *const c_char,
    *const c_char,
    *mut c_void,
) -> VkBool32;

load_function_ptrs!(DebugReportCallbackFunctions, {
    vkCreateDebugReportCallbackEXT(
        instance: VkInstance,
        createInfo: *const VkDebugReportCallbackCreateInfoEXT,
        allocationCallbacks: *const VkAllocationCallbacks,
        debugReportCallback: *mut VkDebugReportCallbackEXT
    ) -> VkResult,

    vkDestroyDebugReportCallbackEXT(
        instance: VkInstance,
        debugReportCallback: VkDebugReportCallbackEXT,
        allocationCallbacks: *const VkAllocationCallbacks
    ) -> (),
});

impl DebugReportCallbackFunctions {
    pub fn new(
        static_functions: &StaticFunctions,
        instance: VkInstance,
    ) -> DebugReportCallbackFunctions {
        DebugReportCallbackFunctions::load(|name| unsafe {
            static_functions.vkGetInstanceProcAddr(instance, name.as_ptr())
                as *const std::ffi::c_void
        })
    }
}
