use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
pub struct VkAccelerationStructureGeometryKHR {
    pub sType: VkStructureType,
    pub pNext: *const c_void,
    pub geometryType: VkGeometryTypeKHR,
    pub geometry: VkAccelerationStructureGeometryDataKHR,
    pub flags: VkGeometryFlagBitsKHR,
}

impl VkAccelerationStructureGeometryKHR {
    pub fn new(
        geometry_type: VkGeometryTypeKHR,
        geometry: VkAccelerationStructureGeometryDataKHR,
        flags: impl Into<VkGeometryFlagBitsKHR>,
    ) -> Self {
        VkAccelerationStructureGeometryKHR {
            sType: VK_STRUCTURE_TYPE_ACCELERATION_STRUCTURE_GEOMETRY_KHR,
            pNext: ptr::null(),
            geometryType: geometry_type,
            geometry,
            flags: flags.into(),
        }
    }
}

unsafe impl Send for VkAccelerationStructureGeometryKHR {}
unsafe impl Sync for VkAccelerationStructureGeometryKHR {}
