use crate::prelude::*;

use std::os::raw::c_void;
use std::ptr;

#[repr(C)]
pub struct VkCopyAccelerationStructureToMemoryInfoKHR {
    pub sType: VkStructureType,
    pub pNext: *const c_void,
    pub src: VkAccelerationStructureKHR,
    pub dst: VkDeviceOrHostAddressKHR,
    pub mode: VkCopyAccelerationStructureModeKHR,
}

impl VkCopyAccelerationStructureToMemoryInfoKHR {
    pub fn new(
        src: VkAccelerationStructureKHR,
        dst: VkDeviceOrHostAddressKHR,
        mode: VkCopyAccelerationStructureModeKHR,
    ) -> Self {
        VkCopyAccelerationStructureToMemoryInfoKHR {
            sType: VK_STRUCTURE_TYPE_COPY_ACCELERATION_STRUCTURE_TO_MEMORY_INFO_KHR,
            pNext: ptr::null(),
            src,
            dst,
            mode,
        }
    }
}
